Reporting Errors

You can emit an error from a Cloud Function to Stackdriver Error Reporting as shown below:

Node.js

// These WILL be reported to Stackdriver Error Reporting
console.error(new Error('I failed you'));
console.error('I failed you', new Error('I failed you too'));
throw new Error('I failed you'); // Will cause a cold start if not caught

// These will NOT be reported to Stackdriver Error Reporting
console.info(new Error('I failed you')); // Logging an Error object at the info level
console.error('I failed you'); // Logging something other than an Error object
throw 1; // Throwing something other than an Error object
callback('I failed you');
res.status(500).send('I failed you');

Python

# This WILL be reported to Stackdriver Error
# Reporting, and WILL NOT show up in logs or
# terminate the function.
from google.cloud import error_reporting
client = error_reporting.Client()

try:
    raise RuntimeError('I failed you')
except RuntimeError:
    client.report_exception()

# This WILL be reported to Stackdriver Error Reporting,
# and WILL terminate the function
raise RuntimeError('I failed you')

# These errors WILL NOT be reported to Stackdriver
# Error Reporting, but will show up in logs.
import logging
print(RuntimeError('I failed you (print to stdout)'))
logging.warn(RuntimeError('I failed you (logging.warn)'))
logging.error(RuntimeError('I failed you (logging.error)'))
sys.stderr.write('I failed you (sys.stderr.write)\n')

# This is considered a successful execution and WILL NOT be reported to
# Stackdriver Error Reporting, but the status code (500) WILL be logged.
from flask import abort
return abort(500)

Go


package tips

import (
	"fmt"
	"net/http"
	"os"
)

// HTTPError describes how errors are handled in an HTTP function.
func HTTPError(w http.ResponseWriter, r *http.Request) {
	// An error response code is NOT reported to Error Reporting.
	// http.Error(w, "An error occurred", http.StatusInternalServerError)

	// Printing to stdout and stderr is NOT reported to Error Reporting.
	fmt.Println("An error occurred (stdout)")
	fmt.Fprintln(os.Stderr, "An error occurred (stderr)")

	// Calling log.Fatal sets a non-zero exit code and is NOT reported to Error
	// Reporting.
	// log.Fatal("An error occurred (log.Fatal)")

	// Panics are reported to Error Reporting.
	panic("An error occurred (panic)")
}

Java


import com.google.cloud.functions.HttpFunction;
import com.google.cloud.functions.HttpRequest;
import com.google.cloud.functions.HttpResponse;
import java.io.IOException;
import java.util.logging.Logger;

public class HelloError implements HttpFunction {

  private static final Logger logger = Logger.getLogger(HelloError.class.getName());

  @Override
  public void service(HttpRequest request, HttpResponse response)
      throws IOException {
    // These will NOT be reported to Stackdriver error reporting
    System.err.println("I failed you");
    logger.severe("I failed you");

    // This WILL be reported to Stackdriver error reporting
    throw new RuntimeException("I failed you");
  }
}

If you would like more fine-grained error reporting, you can use the Stackdriver Error Reporting Client Libraries.

You can view the reported errors in Stackdriver Error Reporting in the Cloud Console. You can also see the errors reported from a particular function when you select it from the list of functions in the Cloud Console.

Uncaught exceptions produced by your function will appear in Stackdriver Error Reporting. Note that some uncaught exceptions, for example, those thrown asynchronously, can cause a cold start on a future function invocation. This reduces function performance.